﻿# -*- coding: utf-8 -*-

import re, string, sys, os, gzip,  math
import urllib.request
from random import random
import base64, time
import json as simplejson
  

UserAgent = 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-GB; rv:1.9.0.3) Gecko/2008092417 Firefox/3.0.3'

RUNFLAG = 0

def GetHttpData(url):
    req = urllib.request.Request(url)
    req.add_header('User-Agent', UserAgent)
    response = urllib.request.urlopen(req)
    httpdata = response.read()
    response.close()
    ret=httpdata.decode('utf-8','ignore')
    match = re.compile('<meta http-equiv="[Cc]ontent-[Tt]ype" content="text/html; charset=(.+?)"').findall(ret)
    if len(match)<=0:
        match = re.compile('meta charset="(.+?)"').findall(ret)
    if len(match)>0:
        charset = match[0].lower()
        if (charset != 'utf-8') and (charset != 'utf8'):
            ret = httpdata.decode(charset,'ignore')
#            httpdata = unicode(httpdata, charset).encode('utf8')
    return ret


class BRTN_DR:
    def GetPlayList(self,vid):
        url = 'http://api.btime.com/video/play?callback=jQuery&id=' + vid 
        link=GetHttpData(url)
        lst = re.compile('jQuery\((.+?)\)').findall(link)
        json_response=simplejson.loads(lst[0])
        irate=0
        iurl=''
        for i in json_response['data']['video_streams'][0]:
            if i['stream_rate'] > irate:
                iurl=i['stream_url']
        return 'SINGLE',iurl


class IFENG_DR:
    def GetPlayList(self,vid):
        url = 'http://vxml.ifengimg.com/video_info_new/' + vid[34:35]+'/'+vid[34:36] + '/' + vid +'.xml'
        link = GetHttpData(url)
        lst = re.compile('<video mediaType="mp4".+?VideoPlayUrl="(.+?)">').findall(link)
        return 'SINGLE',lst[len(lst)-1]




class DENG_DR:
    def GetPlayList(self,vid):
        url='http://www.5ivdo.com/deng.php?ckid='+vid
        link = GetHttpData(url)
        lst = re.compile('<file><\!\[CDATA\[(http.+?)\]\]></file>').findall(link)
        return 'SINGLE',lst[0]






# http://hot.vrs.sohu.com/vrs_flash.action?vid=2339874
class SOHU_DR:
    def __init__( self ):
        return
    def real_url(self,host,vid,tvid,new,clipURL,ck):
        url = 'http://'+host+'/?prot=9&prod=flash&pt=1&file='+clipURL+'&new='+new +'&key='+ ck+'&vid='+str(vid)+'&uid='+str(int(time.time()*1000))+'&t='+str(random())+'&rb=1'
        return simplejson.loads(GetHttpData(url))['url'].encode('utf-8')
    def get_hqvid(self,ppage):
        match = re.compile('"norVid":(.+?),"highVid":(.+?),"superVid":(.+?),"oriVid":(.+?),').search(ppage)
        if match:
            if match.group(4) !='0' : 
                return match.group(4)
            if match.group(3) !='0' : 
                return match.group(3)
            if match.group(2) !='0' : 
                return match.group(2)
            if match.group(1) !='0' : 
                return match.group(1)
        else:
            return 'ERROR'
    def GetPlayList(self,pvid):
        link = GetHttpData('http://hot.vrs.sohu.com/vrs_flash.action?vid='+pvid)
        hqvid = self.get_hqvid(link)
        if hqvid == 'ERROR':
            return 'ERROR',''
        if hqvid != pvid:
            link = GetHttpData('http://hot.vrs.sohu.com/vrs_flash.action?vid='+hqvid)
        info = simplejson.loads(link)
        host = info['allot']
        tvid = info['tvid']
        urls = []
        data = info['data']
#        assert len(data['clipsURL']) == len(data['clipsBytes']) == len(data['su'])
        for new,clip,ck, in zip(data['su'], data['clipsURL'], data['ck']):
#            clipURL = urlparse.urlparse(clip).path
            urls.append(self.real_url(host,hqvid,tvid,new,clipURL,ck)+'|Range=')
        return 'MULTI',urls


def work(purl):
    ips = purl.split(',')
    if ips[0] == 'DR_BRTN':
        itype,iurl=BRTN_DR().GetPlayList(ips[1])
    elif ips[0] == 'DR_SOHU':
        itype,iurl=SOHU_DR().GetPlayList(ips[1])
    elif ips[0] == 'DR_IFENG':
        itype,iurl=IFENG_DR().GetPlayList(ips[1])
    elif ips[0] == 'DR_DENG':
        itype,iurl=DENG_DR().GetPlayList(ips[1])
    else:
        itype ='ERROR'
        iurl=''
    return itype,iurl



def version():
    return '20210429'



